// Copyright (c) 2009-2011 Intel Corporation
// All rights reserved.
//
// WARRANTY DISCLAIMER
//
// THESE MATERIALS ARE PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL INTEL OR ITS
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
// OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THESE
// MATERIALS, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Intel Corporation is the author of the Materials, and requests that all
// problem reports or change requests be submitted to it directly

#include <windows.h>
#include <windowsx.h>
#include <dwmapi.h>
#include <mmsystem.h>
#include <tchar.h>
#include <strsafe.h>
#include <initguid.h>
#include <d3d9.h>
#include <dxva2api.h>
#include <iostream>
#include <string>
#include <vector>
#include "string.h"

#define NO_API_TIMING

#include "../../common/utils.h"
#include "../Common/OCL_Environment.h"

#include <CL/cl_ext.h>
#include <CL/cl_dx9_media_sharing.h>


/************************Function definitions**********************************************/
/***********************OpenCL Related ***********************/
cl_uint generateVideoStream();
cl_uint openCLInvertShared();
cl_uint openCLGaussShared();
cl_uint createFromSharedSurface();
cl_uint openCLStartup();
cl_uint openCLDestroy();
cl_uint registerOpenCLSharedSurfaceExtensions();

/***********************DXVA Functions*************************/
bool InitializeVideo();
bool InitializeDXVA2();
bool InitializeD3D9();
VOID DestroyD3D9();
bool CreateDXVA2VPDevice(REFGUID guid);
VOID DestroyDXVA2();
bool ResetDevice(bool bChangeWindowMode = FALSE);
DWORD GetFrameNumber();
DXVA2_AYUVSample16 GetBackgroundColor();
RECT ScaleRectangle(const RECT& input, const RECT& src, const RECT& dst);
bool ProcessVideo();

/***********************Windowing Related**********************/
VOID OnDestroy(HWND hwnd);
VOID OnKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags);
VOID OnPaint(HWND hwnd);
VOID OnSize(HWND hwnd, UINT state, int cx, int cy);
LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
bool InitializeWindow();
bool InitializeTimer();
VOID DestroyTimer();
INT MessageLoop();
bool InitializeModule();

/*****************Convenience functions ******************/
void readBMPImage();
void RedirectIOToConsole();
